// Output generated from file: D:/IQPath_Light/1-11.frag
// Created:  25.  18:16:11 2017
#version 400
// Output generated from file: D:/fractal/Fragmentarium/Output/CristJRoger/newIQpath/Menger.frag
// Created: Fri Aug 25 16:20:31 2017
#define WANGHASH
//#version 120
//#define OLD_FRAG

#include "MathUtils.frag"
#include "newIQPath.frag"
//#include "iqPath_Light.frag"
//#include "Sky-PathTracer.frag"


#group Menger
uniform int Iterations;  slider[0,8,100]
uniform float Scale; slider[0.00,3.0,4.00]
uniform vec3 Offset; slider[(0,0,0),(1,1,1),(3,3,3)]
uniform bool Use_Floor; checkbox[false]
uniform int ColorIterations;  slider[0,2,100]

float DE(vec3 z)
{
	float p = z.z;
	float r;
	int n = 0;
	z = abs(z);
	if (z.x<z.y){ z.xy = z.yx;}
	if (z.x<z.z){ z.xz = z.zx;}
	if (z.y<z.z){ z.yz = z.zy;}
	if (z.z<1./3.){ z.z -=2.*( z.z-1./3.);}
	while (n < Iterations && dot(z,z)<100.0) {
		z=Scale* (z-Offset)+Offset;
		z = abs(z);
		if (z.x<z.y){ z.xy = z.yx;}
		if (z.x< z.z){ z.xz = z.zx;}
		if (z.y<z.z){ z.yz = z.zy;}
		if (z.z<1./3.*Offset.z){ z.z -=2.*( z.z-1./3.*Offset.z);}
		r = dot(z-Offset, z-Offset);
if (n<ColorIterations) orbitTrap = min(orbitTrap, abs(vec4(z.xyz,dot(z,z))));
		n++;
	}
	//return (length(z)-sqrt(3.) ) * pow(Scale, float(-n));
	return(Use_Floor)? min(p,float(z.x-Offset) * pow(Scale, float(-n))):float(z.x-Offset) * pow(Scale, float(-n));
}



























#preset default
FOV = 0.4
Eye = -2.54531,-2.2073,1.67332
Target = 3.56425,5.05251,-1.48399
Up = 0.2215,0.225998,0.948264
EquiRectangular = false
FocalPlane = 1.41305
Aperture = 0.09
ApertureNbrSides = 2
ApertureRot = 0
ApStarShaped = false
BokehCircle = 2.4
Gamma = 1.81306
ToneMapping = 5
Exposure = 1.13098
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
RayBounces = 5
RaySteps = 1128
FudgeFactor = 1
HitDistance = 0.001
MaxDepth = 20.7123
Mat_Color = 0.694118,0.815686,0.654902
Mat_Refl = 1
Mat_ReflExp = 1
UseTexture = false
DeTex = D:/fractal/Mandelbulb3D/maps/31.jpg
DeTexScale = 0.0348432
DeTexExposure = 0.118064
OrbitStrength = 0
X = 0.823529,0.964706,1,0.1068
Y = 1,0.00392157,0.00392157,1
Z = 1,0.584314,0,1
R = 0.0392157,0.027451,0.0352941,1
CycleColors = false
Cycles = 23.8321
SpotLight = 1,0.8,0.5,10
SpotLightDir = -0.50618,-0.95062
SpotSize = 1.1032
SpotExp = 4.74228
BgColor = 0.0980392,0.223529,0.27451,0.601415
Ambience = 1.134
Fog = 0
GRIter = 3
GRPower = 0
Iterations = 3
Scale = 2.63697
Offset = 1.63392,3,0.9375
Use_Floor = true
ColorIterations = 4
#endpreset

