// Output generated from file: E:/IQPath_Light/Menger.frag
// Created:  24.  00:07:55 2017
//#version 400
//#version 120
#include "MathUtils.frag"
#include "newIQPath.frag"
//#include "iqPath_Light.frag"
//#include "Sky-PathTracer.frag"


#group Menger
uniform int Iterations;  slider[0,8,100]
uniform float Scale; slider[0.00,3.0,4.00]
uniform vec3 Offset; slider[(0,0,0),(1,1,1),(3,3,3)]
uniform bool Use_Floor; checkbox[false]

float DE(vec3 z)
{
	float p = z.z;
	float r;
	int n = 0;
	z = abs(z);
	if (z.x<z.y){ z.xy = z.yx;}
	if (z.x<z.z){ z.xz = z.zx;}
	if (z.y<z.z){ z.yz = z.zy;}
	if (z.z<1./3.){ z.z -=2.*( z.z-1./3.);}
	while (n < Iterations && dot(z,z)<100.0) {
		z=Scale* (z-Offset)+Offset;
		z = abs(z);
		if (z.x<z.y){ z.xy = z.yx;}
		if (z.x< z.z){ z.xz = z.zx;}
		if (z.y<z.z){ z.yz = z.zy;}
		if (z.z<1./3.*Offset.z){ z.z -=2.*( z.z-1./3.*Offset.z);}
		r = dot(z-Offset, z-Offset);
		n++;
	}
	//return (length(z)-sqrt(3.) ) * pow(Scale, float(-n));
	return(Use_Floor)? min(p,float(z.x-Offset) * pow(Scale, float(-n))):float(z.x-Offset) * pow(Scale, float(-n));
}


















































#preset default
FOV = 0.5
Eye = 2.21967,-1.02878,0.199738
Target = -6.57623,3.72747,0.29927
Up = 0.0109563,-1.0963e-05,0.99994
EquiRectangular = false
FocalPlane = 0.9239
Aperture = 0
ApertureNbrSides = 2
ApertureRot = 0
ApStarShaped = false
BokehCircle = 2.7
Gamma = 1.7
ToneMapping = 5
Exposure = 1.7
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
RayBounces = 5
RaySteps = 312
FudgeFactor = 1
HitDistance = 1e-05
MaxDepth = 10.7072
Mat_Color = 0.847059,0.627451,0.513725
Mat_Refl = 0.67
Mat_ReflExp = 0.9878
UseTexture = false
DeTex = 
DeTexScale = 0.5
DeTexExposure = 1
OrbitStrength = 0
X = 0.5,0.6,0.6,0.7
Y = 1,0.6,0,0.4
Z = 0.8,0.78,1,0.5
R = 0.4,0.7,1,0.12
CycleColors = false
Cycles = 1.1
SpotLight = 1,0.686275,0.458824,4.8387
SpotLightDir = -0.49288,-0.23456
SpotSize = 0.4167
SpotExp = 2.06189
BgColor = 0.137255,0.305882,0.458824,1
Ambience = 2.06185
Fog = 0
GRIter = 5
GRPower = 0.47475
Iterations = 4
Scale = 2.77968
Offset = 1.44642,1.76787,0.9375
Use_Floor = true
#endpreset

